#!/usr/bin/env python

"""
This is just a class which is used to hold some predefined reg.
expressions for blocking
"""

__cvsversion__ = '$Id: REBlocks.py,v 1.6 2007/12/06 23:32:20 jay Exp $'
__author__ = 'Jay Deiman; jay@splitstreams.com'
__copyright__ = 'Copyright 2007 Jason Deiman'
__license__ = 'GPLv3'
__all__ = ['REBlocks']

import re , types

class REBlocks(object):
    def __init__(self , config):
        self._config = config
        self._regexes = []
        self._regType = type(re.compile(''))
        self._readRegexFile()
        
    def _readRegexFile(self):
        fh = open(self._config.RegexFile)
        comment = re.compile(r'^\s*#.*')
        whitespace = re.compile(r'^\s*$')
        while True:
            line = fh.readline()
            if not line: break
            if whitespace.match(line) or comment.match(line): continue
            self._regexes.append(re.compile(line.rstrip('\r\n')))
        fh.close()
        
    def addRegex(self , regex):
        if type(regex) is types.StringType:
            self._regexes.append(re.compile(regex))
        elif type(regex) is self._regType:
            self._regexes.append(regex)
        else:
            raise TypeError , 'The argument to addRegex() must be a string' \
                    ' or compiled regex'
    
    def getRegexes(self):
        return self._regexes